(setq scheme-program-name "csi -:c")
(setq comint-prompt-read-only t)

(use-package geiser
  :mode ("\\.scm\\'" . geiser-mode)
  :commands (run-chicken run-guile geiser-mode))
;; (with-eval-after-load 'geiser-mode
;;   (setq geiser-mode-smart-tab-p t)
;;   (define-key geiser-mode-map (kbd "C-.") nil)
;;   ;; (cp-set-keys
;;   ;;  :unset t
;;   ;;  :keymap geiser-mode-map
;;   ;;  :bindings
;;   ;;  `((,(kbd "C-."))))
;;   )

(use-package scheme-mode
  :mode ("\\.scm\\'" . scheme-mode)
  :interpreter "csi")

(defun contrapunctus-lisp-copy (arg)
  "Run `whole-line-or-region-copy-region-as-kill' if region is
active, else `sp-copy-sexp'."
  (interactive "P")
  (if (region-active-p)
      (whole-line-or-region-copy-region-as-kill arg)
    (sp-copy-sexp arg)))

(defun colorize-compilation-buffer ()
  (ansi-color-apply-on-region compilation-filter-start
			      (point)))

(add-hook 'compilation-filter-hook 'colorize-compilation-buffer)

;; Stopped calling `exec-path-from-shell-initialize' on init, but
;; won't this keep running it excessively?
;; `exec-path-from-shell-copy-envs' (which it calls internally)
;; doesn't seem idempotent, either.
(use-package exec-path-from-shell
  :hook
  (compilation-mode . exec-path-from-shell-initialize)
  (shell-mode-hook . exec-path-from-shell-initialize)
  (minibuffer-setup-hook . exec-path-from-shell-initialize))

(use-package skeleton
  :config
  (define-skeleton cp-ql-quickload
    "Insert a `(ql:quickload |)' form."
    nil "(ql:quickload :" _ ")"))

(use-package abbrev
  :hook (lisp-mode . abbrev-mode)
  (slime-repl-mode . abbrev-mode)
  :config
  ;; `slime-repl-mode' is defined as a function rather than using the
  ;; `define-derived-mode' macro, so there's no abbrev table created
  ;; for it. This is adapted from the macro expansion of
  ;; `geiser-repl-mode'.
  (defvar slime-repl-mode-abbrev-table)
  (put 'slime-repl-mode-abbrev-table 'definition-name 'slime-repl-mode)
  (defvar slime-repl-mode-abbrev-table
    (progn
      (define-abbrev-table 'slime-repl-mode-abbrev-table
        `(("qq" "" cp-ql-quickload))
        "Abbrev table for SLIME REPLs.")
      slime-repl-mode-abbrev-table))
  (put 'slime-repl-mode-abbrev-table 'variable-documentation
       (purecopy "Abbrev table for `slime-repl-mode'."))
  (define-abbrev lisp-mode-abbrev-table "qq" "" 'cp-ql-quickload))

(provide 'cp-lisp)
